#version 120

uniform float frameTimeCounter;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec3 pos;
varying vec4 glcolor;

#define IDLE_HANDS //Makes your hands sway back and forth in 1st person, like they do in 3rd person

#ifdef IDLE_HANDS
	vec2 handOffset = vec2(sin(frameTimeCounter * 1.6), sin(frameTimeCounter * 1.2)) / 64.0;
#endif

void main() {
	pos = (gl_ModelViewMatrix * gl_Vertex).xyz;
	gl_Position = ftransform();

	#ifdef IDLE_HANDS
		if (gl_Position.z / gl_Position.w < 0.25) {
			vec4 v = gl_ModelViewMatrix * gl_Vertex;
			v.xy += handOffset * sign(gl_ModelViewMatrix[3][0] + 0.3125);
			gl_Position = gl_ProjectionMatrix * v;
		}
	#endif

	lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	glcolor = gl_Color;
}