#version 120

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform vec3 cameraPosition;
        vec3 eyePosition = cameraPosition + gbufferModelViewInverse[3].xyz; //because cameraPosition isn't actually the position of the camera -_-

varying vec2 beaconPos;
varying vec3 pos;
varying vec4 glcolor;

float square(float x)        { return x * x; } //faster than pow().

float distanceSq2(vec2 p1, vec2 p2) {
	return square(p2.x - p1.x) + square(p2.y - p1.y);
}

void main() {
	vec4 p = gl_ModelViewMatrix * gl_Vertex;
	p = gbufferModelViewInverse * vec4(p.xyz, 0.0);
	beaconPos = floor(p.xz + eyePosition.xz) - eyePosition.xz + 0.5;

	if (distanceSq2(p.xz, beaconPos) > 0.0625) { //transparent layer
		gl_Position = vec4(100.0);
		return;
	}

	p.xz += (p.xz - beaconPos) * 1.5; //make the beam a little bit wider, so that we have more fragments to work with.
	pos = p.xyz;
	p = gbufferModelView * vec4(p.xyz, 0.0);
	gl_Position = gl_ProjectionMatrix * vec4(p.xyz, 1.0);

	glcolor = gl_Color;
}