vec3 calcUnderwaterFogColor(vec3 color, float dist, float brightness) {
	dist *= far;

	vec3 multiplier = exp2(-dist * mix(vec3(0.1875, 0.0625, 0.125), vec3(0.375, 0.3125, 0.25), rainStrength));
	vec3 scatterColor = (skyColor + fogColor) * mix(vec3(0.0625, 0.125, 0.1875), vec3(0.0625), rainStrength) * (1.0 - multiplier) * (brightness * day);
	return color * multiplier + scatterColor;
}

vec3 calcUnderwaterFogColorInfinity(float brightness) {
	//simpler algorithm for the special case where distance = infinity (for infinite oceans)
	return (skyColor + fogColor) * mix(vec3(0.0625, 0.125, 0.1875), vec3(0.0625), rainStrength) * (brightness * day);
}