#ifdef WATER_REFRACT
	vec2 waterNoise(vec2 coord, float time) {
		coord *= invNoiseRes;

		vec2 noise = vec2(0.0);
		noise += (texture2D(noisetex, (coord + goldenOffsets[0] * time)      ).rg - 0.5);          //1.0 / 1.0
		noise += (texture2D(noisetex, (coord + goldenOffsets[1] * time) * 1.5).rg - 0.5) * 0.6666; //1.0 / 1.5
		noise += (texture2D(noisetex, (coord + goldenOffsets[2] * time) * 2.0).rg - 0.5) * 0.5;    //1.0 / 2.0
		noise += (texture2D(noisetex, (coord + goldenOffsets[3] * time) * 2.5).rg - 0.5) * 0.4;    //1.0 / 2.5
		noise += (texture2D(noisetex, (coord + goldenOffsets[4] * time) * 3.0).rg - 0.5) * 0.3333; //1.0 / 3.0
		noise += (texture2D(noisetex, (coord + goldenOffsets[5] * time) * 3.5).rg - 0.5) * 0.2857; //1.0 / 3.5
		noise += (texture2D(noisetex, (coord + goldenOffsets[6] * time) * 4.0).rg - 0.5) * 0.25;   //1.0 / 4.0
		return noise;
	}

	vec2 waterNoiseLOD(vec2 coord, float distance) {
		float lod = log2(distance * 0.0625); //level of detail
		float scale = floor(lod);
		coord *= exp2(-scale); //each time the distance doubles, so will the scale factor
		float middle = fract(lod);
		float time = frameTimeCounter * invNoiseRes * 3.0;

		vec2 noise1 = waterNoise(coord, time / max(scale, 1.0));
		vec2 noise2 = waterNoise(coord * 0.5, time / max(scale + 1.0, 1.0));

		return mix(noise1, noise2, interpolateSmooth1(middle));
	}
#endif

#ifdef ICE_SCATTER
	vec3 iceNoise(vec2 coord) {
		coord *= invNoiseRes;

		vec3 noise = vec3(0.0);
		noise += texture2D(noisetex, coord        ).rgb;
		noise += texture2D(noisetex, coord * 0.5  ).rgb;
		noise += texture2D(noisetex, coord * 0.25 ).rgb;
		noise += texture2D(noisetex, coord * 0.125).rgb;
		noise -= 2.0; //0.5 * 4.0
		return noise;
	}

	vec3 iceNoiseLOD(vec2 coord, float distance) {
		float lod = log2(distance); //level of detail
		float scale = exp2(-floor(lod)); //each time the distance doubles, so will the scale factor
		coord *= scale;
		float middle = fract(lod);

		vec3 noise1 = iceNoise(coord      );
		vec3 noise2 = iceNoise(coord * 0.5);

		return mix(noise1, noise2, interpolateSmooth1(middle));
	}
#endif