vec3 calcUnderwaterFogColor(vec3 color, float dist, float brightness) {
	dist *= far; //use absolute distance, not relative distance

	vec3 multiplier = exp2(-dist * vec3(0.1875, 0.0625, 0.125));
	vec3 scatterColor = (skyColor + fogColor) * vec3(0.0625, 0.125, 0.1875) * (1.0 - multiplier) * brightness;
	return color * multiplier + scatterColor;
}

vec3 calcUnderwaterFogColorInfinity(float brightness) {
	//simpler algorithm for the special case where distance = infinity (for looking at unobstructed sky while underwater)
	return (skyColor + fogColor) * vec3(0.0625, 0.125, 0.1875) * brightness;
}