#version 120

uniform float rainStrength;
uniform int worldTime;
uniform vec3 sunPosition;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec3 pos;
varying vec4 glcolor;

void main() {
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	gl_Position = ftransform();
	pos = (gl_ModelViewMatrix * gl_Vertex).xyz;
	glcolor = gl_Color;

	float adjustedTime = abs(mod(worldTime / 1000.0 + 6.0, 24.0) - 12.0);
	float night = clamp(adjustedTime - 6.7, 0.0, 1.0);

	vec3 sunPosNorm = normalize(sunPosition);

	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	#include "/lib/glmult.glsl"
}