#version 120

uniform float viewHeight;
uniform float viewWidth;
uniform mat4 gbufferProjectionInverse;
uniform sampler2D texture;
uniform vec3 cameraPosition;
uniform vec3 upPosition;

varying vec2 texcoord;
varying vec4 glcolor;

#define INFINITE_OCEANS //Simulates water out to the horizon instead of just your render distance.

vec3 upPosNorm = normalize(upPosition);

#include "/lib/math.glsl"

void main() {
	vec4 color = texture2D(texture, texcoord) * glcolor;

	#ifdef INFINITE_OCEANS
		vec2 tc = gl_FragCoord.xy / vec2(viewWidth, viewHeight);
		vec3 pos = normalize((gbufferProjectionInverse * vec4(tc * 2.0 - 1.0, 1.0, 1.0)).xyz);
		float upDot = dot(pos, upPosNorm) * square(max(cameraPosition.y, 256.0) / 256.0 + 1.0) * 0.5;
		color.rgb *= 1.0 - fogify(max(upDot, 0.0), 0.0625);
	#endif

/* DRAWBUFFERS:0 */
	gl_FragData[0] = color; //gcolor
}