#version 120

uniform float viewWidth;
uniform float viewHeight;
uniform sampler2D depthtex0;
uniform sampler2D texture;

#define CLOUDS //3D clouds (partially volumetric too). Mild performance impact!
#define CLOUD_HEIGHT 256.0 //Y level of fancy clouds [128.0 144.0 160.0 176.0 192.0 208.0 224.0 240.0 256.0 272.0 288.0 304.0 320.0 336.0 352.0 368.0 384.0 400.0 416.0 432.0 448.0 464.0 480.0 496.0 512.0]

varying vec2 texcoord;
varying vec3 worldPos;
varying vec4 glcolor;

void main() {
	float depth = texture2D(depthtex0, gl_FragCoord.xy / vec2(viewWidth, viewHeight)).r;
	if (depth == 1.0) discard; //only draw rain over the terrain, not the sky.
	#ifdef CLOUDS
		if (worldPos.y > CLOUD_HEIGHT) discard; //don't draw rain above clouds.
	#endif

/* DRAWBUFFERS:0 */
	gl_FragData[0] = texture2D(texture, texcoord) * glcolor; //gcolor
}