#version 120

uniform float viewHeight;
uniform float viewWidth;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferProjectionInverse;
uniform vec3 cameraPosition;
uniform vec3 fogColor;
uniform vec3 skyColor;

//#define CUBIC_CHUNKS //Disables black fog/sky colors below Y=0

varying vec4 starData; //rgb = star color, a = flag for weather or not this pixel is a star.

#include "/lib/math.glsl"

#include "/lib/otherDims/twilight_forest/calcFogColor.glsl"

void main() {

/* DRAWBUFFERS:0 */
	gl_FragData[0] = starData.a > 0.9 ? starData : vec4(calcFogColor(normalize((gbufferProjectionInverse * vec4(gl_FragCoord.xy / vec2(viewWidth, viewHeight) * 2.0 - 1.0, 1.0, 1.0)).xyz)), 1.0); //gcolor
}